SystemOrganization addCategory: #'Seaside-JSON-Component'!

WAAdmin subclass: #WAJsonAdmin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-JSON-Component'!

!WAJsonAdmin class methodsFor: 'configuration' stamp: 'pmm 9/24/2011 10:49'!
applicationDefaults
	| config |
	config := WASharedConfiguration named: 'JSON Application Defaults'.
	(configuredApplicationDefaults ifNil: [ false ]) ifFalse: [
		self configureApplicationDefaults: config.
		configuredApplicationDefaults := true ].
	^ config! !

!WAJsonAdmin class methodsFor: 'initialization' stamp: 'pmm 9/24/2011 10:50'!
configureApplicationDefaults: aSharedConfiguration
	"WARenderLoopConfiguration is added by default because most users will use WASession and the Render Loop."
	(aSharedConfiguration parents includes: WAApplicationConfiguration instance) ifFalse: [
		aSharedConfiguration
			addParent: WAApplicationConfiguration instance;
			at: #documentClass put: WAJsonDocument;
			at: #actionPhaseContinuationClass put: WAJsonActionContinuation;
			at: #renderPhaseContinuationClass put: WAJsonRenderContinuation;
			at: #mimeType put: 'application/json' ]! !

WARenderPhaseContinuation subclass: #WAJsonRenderContinuation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-JSON-Component'!

!WAJsonRenderContinuation methodsFor: 'processing' stamp: 'pmm 9/24/2011 10:07'!
handleRequest
	self respond: [ :response | self processRendering: response ].

	"The render phase should have returned a response"
	WAMissingResponseError signal! !

!WAJsonRenderContinuation methodsFor: 'processing' stamp: 'pmm 9/24/2011 10:10'!
processRendering: aResponse 
	| document actionContinuation renderContext actionUrl actionBaseUrl |
	"Prepare the response"
	aResponse contentType: self application contentType.

	"Create objects we need"
	document := self requestContext newDocument.
	actionContinuation := self createActionContinuation.
	renderContext := self createRenderContext.
	
	"Create URL"
	actionUrl := actionContinuation registerForUrl: false.
	actionBaseUrl := actionUrl copy.
	self updateUrl: actionUrl.

	"Hook objects together"
	renderContext
		document: document;
		actionUrl: actionUrl;
		actionBaseUrl: actionBaseUrl;
		resourceUrl: self application resourceBaseUrl.
	actionContinuation renderContext: renderContext.

	"Render"
	self presenter renderWithContext: renderContext.
	document close.
	renderContext destroy! !

WAActionPhaseContinuation subclass: #WAJsonActionContinuation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-JSON-Component'!

WAComponent subclass: #WAJsonComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-JSON-Component'!

!WAJsonComponent methodsFor: 'rendering' stamp: 'pmm 9/24/2011 10:00'!
rendererClass
	^ WAJsonCanvas! !
